package jugs.javafx.a_basics;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.text.Text;
import javafx.stage.Stage;


/**
 * Beispielprogramm für JavaFX-Schulung
 * <br>
 * <b>Neu in Auflage 2</b>
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise1a_FirstJavaFxExample extends Application {

	final ToggleGroup group = new ToggleGroup();
	final RadioButton rb1 = new RadioButton(" => ");
	final RadioButton rb2 = new RadioButton(" => ");
	final RadioButton rb3 = new RadioButton(" => ");
	final RadioButton rb4 = new RadioButton(" => ");
	
	final Label label = new Label("Label");
	final Text text = new Text("Text");
	final Button button = new Button("Button");	
	final TextField textfield = new TextField("TextField");	
	
	public static void main(final String[] args) {

		launch(Exercise1a_FirstJavaFxExample.class, args);
	}

	@Override
	public void start(final Stage stage) throws Exception {

		// �hnlich wie JFrame ContentPane, Content aufbauen
		final HBox rootPane = new HBox();
		final Scene scene = new Scene(rootPane, 750, 300);		

		// Mit Content bef�llen
		final VBox vboxLeft = new VBox(5);
		vboxLeft.getChildren().add(new Label("CSS:"));
		final TextArea cssEditor = new TextArea();
		cssEditor.setMaxWidth(400);
		vboxLeft.getChildren().add(cssEditor);
		final Button applyBtn = new Button("Apply");
		vboxLeft.getChildren().add(applyBtn);
		
		// Zu stylende Nodes
		rb1.setToggleGroup(group);
		rb1.setSelected(true);
		rb2.setToggleGroup(group);
		rb3.setToggleGroup(group);
		rb4.setToggleGroup(group);
		
		final GridPane gridPane = new GridPane();
		gridPane.setPadding(new Insets(7)); // wieso heißt die nicht setInsets(=???
		gridPane.setHgap(5);
		gridPane.setVgap(5);

		gridPane.add(rb1, 0, 0);
		gridPane.add(rb2, 0, 1);
		gridPane.add(rb3, 0, 2);
		gridPane.add(rb4, 0, 3);
		gridPane.add(label, 1, 0);
		gridPane.add(text, 1, 1);
		gridPane.add(button, 1, 2);
		gridPane.add(textfield, 1, 3);

		rootPane.setPadding(new Insets(10));
		rootPane.getChildren().addAll(vboxLeft, gridPane);
		stage.setScene(scene);

		// Titel und Resizable-Eigenschaft setzen
		stage.setTitle("FirstJavaFxExample");
		stage.setResizable(true);

		// Positionierung und Sichtbarkeit
		stage.centerOnScreen();
		stage.show();
	}
}
