package jugs.javafx.a_basics;

import java.io.File;

import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.Tab;
import javafx.scene.control.TabPane;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.FileChooser;
import javafx.stage.Stage;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise2_TabExample extends Application
{
    @Override
    public void start(final Stage primaryStage)
    {
        final TabPane tabPane = new TabPane();

        // Create Tabs
        tabPane.getTabs().add(createTabA());
        tabPane.getTabs().add(createTabB());
        tabPane.getTabs().add(createFileChooserTab());

        final Scene scene = new Scene(tabPane, 400, 300, Color.WHITE);

        primaryStage.setTitle("Exercise4_TabExample");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    private Tab createTabA()
    {
        final Tab tab = new Tab();
        tab.setText("Tab A");

        // Add something in Tab
        final HBox hbox = new HBox();
        hbox.setPadding(new Insets(7));
        hbox.setSpacing(5);

        // Lernziel
        hbox.setAlignment(Pos.BASELINE_LEFT);
        final Label label = new Label("Enter your name:");
        final TextField textfield = new TextField("TextField");

        hbox.getChildren().addAll(label, textfield);
        tab.setContent(hbox);

        return tab;
    }

    protected Tab createTabB()
    {
        final Tab tab = new Tab();
        tab.setText("Tab B");

        // Add something in Tab
        final StackPane tabB_stack = new StackPane();
        tabB_stack.setAlignment(Pos.CENTER);
        tabB_stack.getChildren().add(new Label("Label@Tab B"));
        tab.setContent(tabB_stack);

        return tab;
    }

    private Tab createFileChooserTab()
    {
        final Tab tab = new Tab();
        tab.setText("FileChooser");

        final Button choose = new Button("Choose File...");
        final ImageView imageView = new ImageView();
        choose.setOnAction(evt -> {
            final FileChooser fileChooser = new FileChooser();
            final File selectedFile = fileChooser.showOpenDialog(null);

            if (selectedFile != null)
            {
                final Image image = new Image(selectedFile.toURI().toString());
                imageView.setImage(image);
            }
        });
        final ScrollPane scrollPane = new ScrollPane(imageView);

        final VBox vbox = new VBox();
        vbox.setPadding(new Insets(7));
        vbox.setSpacing(5);
        vbox.getChildren().addAll(choose, scrollPane);

        tab.setContent(vbox);

        return tab;
    }

    public static void main(String[] args)
    {
        launch(args);
    }

}