package jugs.javafx.c_tables;

import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;
import javafx.util.Callback;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
class GenderOwnRenderer implements Callback<TableColumn<PersonEx, Gender>, TableCell<PersonEx, Gender>>
{
    @Override
    public TableCell<PersonEx, Gender> call(TableColumn<PersonEx, Gender> param)
    {
        return new GenderCell();
    }
}

class GenderCell extends TableCell<PersonEx, Gender>
{
    private final Image femaleIcon = new Image(getClass().getResourceAsStream("Female.png"));

    @Override
    public void updateItem(Gender item, boolean empty)
    {
        super.updateItem(item, empty);
        if (item != null)
        {
            if (item == Gender.FEMALE)
            {
                setGraphic(new ImageView(femaleIcon));
            }
            else if (item == Gender.MALE)
            {
                setTextFill(Color.BLUE);
                
                final Canvas canvas = new Canvas(30, 30);
                final GraphicsContext g = canvas.getGraphicsContext2D();
                
                g.clearRect(0, 0, canvas.getWidth(), canvas.getHeight());
                g.setFill(Color.DARKBLUE);
                g.setLineWidth(5);
                g.strokeOval(5, 10, 15, 15);
                g.setStroke(Color.BLUE);
                g.strokeLine(17, 10, 27, 3);
                g.strokeLine(27, 3, 15, 3);
                g.strokeLine(27, 3, 27, 15);
                setGraphic(canvas);
            }
        }
        else
        {
            setText(null);
        }
    }
}
