package jugs.javafx.e_update40;

import javafx.application.Application;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Modality;
import javafx.stage.Stage;
import javafx.stage.WindowEvent;

/**
 * Beispielprogramm für JavaFX-Schulung 
 * 
 * @author Michael Inden
 * 
 * Copyright 2015 by Michael Inden 
 */
public class Exercise1_DialogsJDK7Example extends Application
{
    @Override
    public void start(final Stage primaryStage)
    {
        primaryStage.setOnCloseRequest(new EventHandler<WindowEvent>()
        {
            @Override
            public void handle(WindowEvent event)
            {
                final Stage dialog = new Stage();
                dialog.initModality(Modality.APPLICATION_MODAL);

                Label label = new Label("Wollen Sie wirklich das Programm beenden?");

                Button okBtn = new Button("Ja");
                okBtn.setOnAction(new EventHandler<ActionEvent>()
                {
                    @Override
                    public void handle(ActionEvent event)
                    {
                        dialog.close();
                    }
                });

                Button cancelBtn = new Button("Nein");
                cancelBtn.setOnAction(new EventHandler<ActionEvent>()
                {
                    @Override
                    public void handle(ActionEvent event)
                    {
                        primaryStage.show();
                        dialog.close();
                    }
                });

                HBox hbox = new HBox();
                hbox.setPadding(new Insets(7));
                hbox.setSpacing(10);
                hbox.setAlignment(Pos.CENTER);
                hbox.getChildren().add(okBtn);
                hbox.getChildren().add(cancelBtn);

                VBox vbox = new VBox();
                vbox.setPadding(new Insets(7));
                vbox.setSpacing(7);
                vbox.setAlignment(Pos.CENTER);
                vbox.getChildren().add(label);
                vbox.getChildren().add(hbox);

                // Stage befuellen
                Scene scene = new Scene(vbox);
                dialog.setScene(scene);
                dialog.show();
            }
        });

        Scene scene = new Scene(new Label("Please close me!"), 300, 250);

        primaryStage.setTitle("DialogsJDK7Example");
        primaryStage.setScene(scene);
        primaryStage.show();
    }

    public static void main(String[] args)
    {
        launch(args);
    }
}